Unit DE03R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE02R_p, UTDE20_p;

procedure DE03R(FU :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; var A :Array of Real;
                HMIN :Real; EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var R :Array of Real;
                var IERR :Integer);
implementation

procedure DE03R(FU :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; var A :Array of Real;
                HMIN :Real; EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var R :Array of Real;
                var IERR :Integer);
var
I,I1,I10,I2,I3,I4,I5,I6,I7,I8,I9,JSTART :Integer;
H1,HS,X :Real;
BUL :Boolean;
label
_10,_20,_30,_40,_50;
begin
I  := M*M;
I1  := 2 + M;
I2  := I1 + I;
I3  := I2 + I;
I4  := I3 + I;
I5  := I4 + I;
I6  := I5 + M;
I7  := I6 + M;
I8  := I7 + M;
I9  := I8 + M;
I10  := I9 + M;
for I:=1 to M do
 begin
  Y[I-1] := YN[I-1];
_10:
 end;
X  := XN;
if ( XK  = X ) 
 then goto _50;
H  := Sign(H,XK-X);
BUL  := False;
JSTART  := 0;
_20:
if (  not BUL ) 
 then goto _30;
H  := HS;
goto _50;
_30:
H1  := XK - X;
if ( Abs(H1)  > Abs(H) )
 then goto _40;
HS  := H;
H  := H1;
JSTART  := 0;
BUL  := True;
_40:
DE02R(FU,M,JSTART,A,HMIN,EPS,P,Y,X,H,BUL,R[0],R[1],
            R[I1-1],R[I2-1],R[I3-1],R[I4-1],R[I5-1],R[I6-1],R[I7-1],R[I8-1],
            R[I9-1],R[I10-1],IERR);
if ( IERR  = 0 )
 then goto _20;
UTDE20(IERR,3);
_50:
end;

end.
